"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.channelsReducers = exports.channelReducer = void 0;
var R = require("ramda");
var channel_interface_1 = require("./channel.interface");
var definition_1 = require("../definition");
/**
 * @stable [21.05.2018]
 * @param {IReduxChannelsEntity} state
 * @param {AnyAction} action
 * @returns {IReduxChannelsEntity}
 */
function channelReducer(state, action) {
    var _a, _b, _c, _d, _e, _f;
    if (state === void 0) { state = definition_1.INITIAL_REDUX_CHANNELS_ENTITY; }
    var current;
    var message = action.data;
    switch (action.type) {
        case channel_interface_1.$CHANNEL_CONNECTED_ACTION_TYPE:
            return __assign(__assign({}, state), (_a = {}, _a[message.ip] = __assign(__assign({}, state[message.ip]), { connected: true }), _a));
        case channel_interface_1.$CHANNEL_DISCONNECTED_ACTION_TYPE:
            return __assign(__assign({}, state), (_b = {}, _b[message.ip] = __assign(__assign({}, state[message.ip]), { connected: false }), _b));
        case channel_interface_1.$CHANNEL_DESTROY_MESSAGE_ACTION_TYPE:
            current = state[message.ip] || {};
            return __assign(__assign({}, state), (_c = {}, _c[message.ip] = __assign(__assign({}, current), { messages: R.filter(message.filter, current.messages || []) }), _c));
        case channel_interface_1.$CHANNEL_MESSAGE_ACTION_TYPE:
            switch (message.name) {
                case channel_interface_1.CHANNEL_CONNECT_MESSAGE:
                    return __assign(__assign({}, state), (_d = {}, _d[message.ip] = __assign(__assign({}, definition_1.INITIAL_REDUX_CHANNELS_ENTITY), { connected: true }), _d));
                case channel_interface_1.CHANNEL_DISCONNECT_MESSAGE:
                    return __assign(__assign({}, state), (_e = {}, _e[message.ip] = __assign(__assign({}, definition_1.INITIAL_REDUX_CHANNELS_ENTITY), { connected: false }), _e));
                default:
                    current = state[message.ip] || {};
                    return __assign(__assign({}, state), (_f = {}, _f[message.ip] = __assign(__assign({}, current), { messages: (current.messages || []).concat(message) }), _f));
            }
    }
    return state;
}
exports.channelReducer = channelReducer;
/**
 * @stable [21.05.2018]
 */
exports.channelsReducers = {
    channel: channelReducer,
};
//# sourceMappingURL=channel.reducer.js.map