import { IEffectsAction } from 'redux-effects-promise';
import { AnyT } from '../../definitions.interface';
import { GenericComponent } from './generic.component';
import { DynamicRoutesT, IAuth, IDialogFormChangesConfirmStoreProxy, IDictionaryStoreProxy, IFormStoreProxy, IGenericContainer, IGenericContainerProps, IListStoreProxy, INotificationStoreProxy, IOperationEntity, IPermissionsManager, IReduxUserEntity, IRouterStoreProxy, IStoreProxy, ITabPanelStoreProxy, IUserActivityManager } from '../../definition';
export declare class GenericContainer<TProps extends IGenericContainerProps = IGenericContainerProps, TState = {}, TSelfRef = AnyT, TPermission = {}> extends GenericComponent<TProps, TState, TSelfRef> implements IGenericContainer<TProps> {
    private $auth;
    private $dfccStoreProxy;
    private $dictionaryStoreProxy;
    private $dynamicRoutes;
    private $formStoreProxy;
    private $listStoreProxy;
    private $notificationStoreProxy;
    private $permissionsManager;
    private $routerStoreProxy;
    private $storeProxy;
    private $tabPanelStoreProxy;
    private $userActivityManager;
    /**
     * @stable [27.11.2019]
     * @returns {IDialogFormChangesConfirmStoreProxy}
     */
    get dfccStoreProxy(): IDialogFormChangesConfirmStoreProxy;
    /**
     * @stable [30.11.2019]
     * @returns {IFormStoreProxy}
     */
    get formStoreProxy(): IFormStoreProxy;
    /**
     * @stable [12.04.2020]
     * @returns {IFormStoreProxy}
     */
    get tabPanelStoreProxy(): ITabPanelStoreProxy;
    /**
     * @stable [30.03.2020]
     * @returns {IListStoreProxy}
     */
    get listStoreProxy(): IListStoreProxy;
    /**
     * @stable [18.12.2019]
     * @returns {IRouterStoreProxy}
     */
    get routerStoreProxy(): IRouterStoreProxy;
    /**
     * @stable [30.03.2020]
     * @returns {INotificationStoreProxy}
     */
    get notificationStoreProxy(): INotificationStoreProxy;
    /**
     * @stable [29.02.2020]
     * @returns {IDictionaryStoreProxy}
     */
    get dictionaryStoreProxy(): IDictionaryStoreProxy;
    /**
     * @stable [30.03.2020]
     * @param {string} type
     * @param {TChanges} data
     */
    dispatch<TChanges = {}>(type: string, data?: TChanges): void;
    /**
     * @stable [30.03.2020]
     * @param {IEffectsAction} action
     */
    dispatchPlainAction(action: IEffectsAction): void;
    /**
     * @stable [30.03.2020]
     * @param {string} type
     * @param {TData} data
     */
    dispatchActionByType<TData = {}>(type: string, data?: TData): void;
    /**
     * @stable [23.04.2020]
     * @returns {string}
     */
    protected get sectionName(): string;
    /**
     * @stable [16.04.2020]
     * @returns {TUser}
     */
    protected getUser<TUser extends IReduxUserEntity>(): TUser;
    /**
     * @stable [30.03.2020]
     * @param {string | IOperationEntity} operations
     * @returns {boolean}
     */
    protected hasTransportWorkingOperations(...operations: (string | IOperationEntity)[]): boolean;
    /**
     * @stable [30.03.2020]
     * @param {TPermission} permission
     * @returns {boolean}
     */
    protected hasPermission(permission: TPermission): boolean;
    /**
     * @stable [30.03.2020]
     * @returns {IStoreProxy}
     */
    protected get storeProxy(): IStoreProxy;
    /**
     * @stable [30.03.2020]
     * @returns {IPermissionsManager<TPermission>}
     */
    protected get permissionsManager(): IPermissionsManager<TPermission>;
    /**
     * @stable [30.03.2020]
     * @returns {IUserActivityManager}
     */
    protected get userActivityManager(): IUserActivityManager;
    /**
     * @stable [12.06.2020]
     * @returns {IAuth}
     */
    protected get auth(): IAuth;
    /**
     * @stable [12.06.2020]
     * @returns {DynamicRoutesT}
     */
    protected get dynamicRoutes(): DynamicRoutesT;
}
