import * as React from 'react';
import { GenericComponent } from '../../base/generic.component';
import { IGridColumnProps } from '../../../definition';
export declare class BaseGridColumn<TProps extends IGridColumnProps = IGridColumnProps> extends GenericComponent<TProps> {
    /**
     * @stable [28.07.2020]
     * @param style
     */
    protected getStyle(style?: TProps): React.CSSProperties;
    /**
     * @stable [18.10.2019]
     * @param {string} classNames
     * @returns {string}
     */
    protected getClassName(...classNames: string[]): string;
    /**
     * @stable [04.01.2020]
     * @returns {JSX.Element}
     */
    protected get columnContentElement(): JSX.Element;
    /**
     * @stable [04.01.2020]
     * @returns {React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement>}
     */
    protected getColumnContentProps(): React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement>;
    /**
     * @stable [04.01.2020]
     * @param {React.ReactNode} children
     * @returns {React.ReactNode}
     */
    protected getColumnContentElement(children: React.ReactNode): React.ReactNode;
}
