import { IGenericComponent, IGenericPlugin, ISelectedElementComponentProps } from '../../definition';
export declare class SelectedElementPlugin implements IGenericPlugin {
    private readonly component;
    private readonly domAccessor;
    /**
     * @stable [23.10.2019]
     * @param {IGenericComponent} component
     */
    constructor(component: IGenericComponent<ISelectedElementComponentProps>);
    /**
     * @stable [23.10.2019]
     */
    componentDidMount(): void;
    /**
     * @stable [25.10.2019]
     */
    componentDidUpdate(): void;
    /**
     * @stable [19.12.2019]
     */
    private refreshScrollPosition;
    /**
     * @stable [20.05.2020]
     * @returns {Element}
     */
    private get selectedElement();
    /**
     * @stable [20.05.2020]
     * @returns {Element}
     */
    private get stickyElement();
    /**
     * @stable [08.06.2020]
     * @returns {ISelectedElementComponentProps}
     */
    private get originalProps();
    /**
     * @stable [21.04.2020]
     * @returns {HTMLElement}
     */
    private get selfRef();
}
