"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.DictionaryStoreProxy = void 0;
var store_proxy_1 = require("../store.proxy");
var action_1 = require("../../../../action");
var DictionaryStoreProxy = /** @class */ (function (_super) {
    __extends(DictionaryStoreProxy, _super);
    /**
     * @stable [30.03.2020]
     * @param {IGenericContainer<TProps extends IGenericContainerProps>} container
     */
    function DictionaryStoreProxy(container) {
        var _this = _super.call(this, container) || this;
        _this.container = container;
        _this.dispatchLoadDictionaryOnChange = _this.dispatchLoadDictionaryOnChange.bind(_this);
        return _this;
    }
    /**
     * @stable [07.08.2020]
     * @param dictionary
     * @param payload
     */
    DictionaryStoreProxy.prototype.dispatchLoadDictionaryOnChange = function (dictionary, payload) {
        this.dispatchLoadDictionary(dictionary, payload);
    };
    /**
     * @stable [07.08.2020]
     * @param dictionary
     * @param payload
     * @private
     */
    DictionaryStoreProxy.prototype.dispatchLoadDictionary = function (dictionary, payload) {
        this.dispatchPlainAction(action_1.DictionariesActionBuilder.buildLoadPlainAction(dictionary, payload));
    };
    return DictionaryStoreProxy;
}(store_proxy_1.StoreProxy));
exports.DictionaryStoreProxy = DictionaryStoreProxy;
//# sourceMappingURL=dictionary-store.proxy.js.map