/// <reference types="react" />
import { IPresetsMinMaxEntity, ISliderProps, ISliderState } from '../../definition';
import { GenericComponent } from '../base/generic.component';
/**
 * @component-impl
 * @stable [16.10.2020]
 */
export declare class Slider<TProps extends ISliderProps = ISliderProps, TState extends ISliderState = ISliderState> extends GenericComponent<TProps, TState> {
    static readonly defaultProps: ISliderProps;
    private readonly attachmentRef;
    private slider;
    /**
     * @stable [16.10.2020]
     * @param originalProps
     */
    constructor(originalProps: TProps);
    /**
     * @stable [16.10.2020]
     */
    render(): JSX.Element;
    /**
     * @stable [16.10.2020]
     */
    componentDidMount(): void;
    /**
     * @stable [16.10.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [16.10.2020]
     * @protected
     */
    protected get componentsSettingsProps(): TProps;
    /**
     * @stable [15.10.2020]
     * @protected
     */
    protected get valuesElement(): JSX.Element;
    /**
     * @stable [16.10.2020]
     * @protected
     */
    protected get minMaxEntity(): IPresetsMinMaxEntity;
    /**
     * @stable [15.10.2020]
     * @param min
     * @param max
     * @private
     */
    private onChangeValues;
    /**
     * @stable [16.10.2020]
     * @param value
     * @private
     */
    private onMinValueChange;
    /**
     * @stable [16.10.2020]
     * @param value
     * @private
     */
    private onMaxValueChange;
    /**
     * @stable [16.10.2020]
     * @param entity
     * @private
     */
    private onChangeManually;
    /**
     * @stable [15.10.2020]
     * @param min
     * @param max
     * @private
     */
    private onUpdateValues;
    /**
     * @stable [15.10.2020]
     * @private
     */
    private get currentValue();
}
