import { ILockPageWrapper, IPageSizeWrapper, IPageWrapper, ITotalAmountWrapper, ITotalCountWrapper } from '../definitions.interface';
import { IReduxLifeCycleEntity } from './entity-definition.interface';
/**
 * @stable [18.05.2020]
 */
export declare const DEFAULT_LOCAL_PAGE_SIZE = 20;
export declare const DEFAULT_MAX_PAGE_SIZE = 1000000;
export declare const DEFAULT_PAGE_SIZE = 50;
export declare const FIRST_PAGE = 1;
/**
 * @default-entity
 * @stable [18.09.2019]
 */
export declare const DEFAULT_MAX_PAGED_ENTITY: Readonly<IReduxPagedEntity>;
/**
 * @default-entity
 * @stable [17.06.2020]
 */
export declare const DEFAULT_PAGED_ENTITY: Readonly<IReduxPagedEntity>;
/**
 * @default-entity
 * @stable [12.10.2019]
 */
export declare const DEFAULT_PAGINATED_SINGLE_ENTITY: Readonly<IReduxPaginatedEntity>;
/**
 * @redux-entity
 * @stable [08.05.2020]
 */
export interface IReduxPagedEntity extends IPageWrapper, IPageSizeWrapper {
}
/**
 * @redux-entity
 * @stable [08.05.2020]
 */
export interface IReduxPaginatedEntity extends IReduxPagedEntity, ILockPageWrapper, ITotalAmountWrapper, ITotalCountWrapper {
}
/**
 * @redux-entity
 * @stable [08.05.2020]
 */
export interface IReduxPaginatedLifeCycleEntity extends IReduxPaginatedEntity, IReduxLifeCycleEntity {
}
