"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DEFAULT_NUMBER_CONVERTER_SETTINGS_ENTITY = exports.DEFAULT_MESSAGES_SETTINGS_ENTITY = exports.DEFAULT_URLS_SETTINGS_ENTITY = exports.DEFAULT_PHONE_SETTINGS_ENTITY = exports.DEFAULT_GOOGLE_MAPS_SETTINGS_ENTITY = exports.DEFAULT_ASYNC_LIBRARIES_SETTINGS_ENTITY = exports.DEFAULT_OAUTH_SETTINGS_ENTITY = exports.DEFAULT_ROUTES_SETTINGS_ENTITY = exports.DEFAULT_COMPONENTS_SETTINGS_ENTITY = exports.DEFAULT_ELEMENTS_MARKERS_SETTINGS_ENTITY = exports.DEFAULT_DATE_TIME_SETTINGS_ENTITY = exports.DEFAULT_CURRENCY_SETTINGS_ENTITY = exports.StartDaysOfWeekEnum = void 0;
var dom_definition_interface_1 = require("./dom-definition.interface");
/**
 * @stable [03.05.2020]
 */
var StartDaysOfWeekEnum;
(function (StartDaysOfWeekEnum) {
    StartDaysOfWeekEnum[StartDaysOfWeekEnum["MONDAY"] = 0] = "MONDAY";
    StartDaysOfWeekEnum[StartDaysOfWeekEnum["SUNDAY"] = 1] = "SUNDAY";
})(StartDaysOfWeekEnum = exports.StartDaysOfWeekEnum || (exports.StartDaysOfWeekEnum = {}));
/**
 * @default-entity
 * @stable [09.09.2020]
 */
exports.DEFAULT_CURRENCY_SETTINGS_ENTITY = Object.freeze({
    currency: 'USD',
    fractionalFormatOptions: {
        maximumFractionDigits: 2,
        minimumFractionDigits: 2,
    },
    integerFormatOptions: {
        maximumFractionDigits: 0,
        minimumFractionDigits: 0,
    },
    locale: 'en-US',
    shortCurrency: '$',
});
/**
 * @stable [25.12.2019]
 */
var defaultDateTimeSettingsEntity = {
    dateTimeFormat: 'YYYY-MM-DD[T]HH:mm:ssZ',
    maxDate: new Date('01/01/4000'),
    minDate: new Date('01/01/1900'),
    startDayOfWeek: StartDaysOfWeekEnum.MONDAY,
    uiDateFormat: 'YYYY-MM-DD',
    uiDateMask: [/\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, '-', /\d/, /\d/],
    uiDatePattern: '[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])',
    uiDefaultTime: '00:00:00',
    uiTimeFormat: 'HH:mm:ss',
    uiYearMonthFormat: 'MMMM YYYY',
    uiYearPattern: '[0-9]{4}',
};
Reflect.defineProperty(defaultDateTimeSettingsEntity, 'currentDate', {
    get: function () { return new Date(); },
});
/**
 * @stable [25.12.2019]
 */
exports.DEFAULT_DATE_TIME_SETTINGS_ENTITY = Object.freeze(defaultDateTimeSettingsEntity);
/**
 * @default-entity
 * @stable [20.05.2020]
 */
exports.DEFAULT_ELEMENTS_MARKERS_SETTINGS_ENTITY = Object.freeze({
    selectedElement: dom_definition_interface_1.ElementsMarkersEnum.SELECTED_ELEMENT_817ACCF6,
    stickyElement: dom_definition_interface_1.ElementsMarkersEnum.STICKY_ELEMENT_275B4646,
});
/**
 * @default-entity
 * @stable [24.03.2020]
 */
exports.DEFAULT_COMPONENTS_SETTINGS_ENTITY = Object.freeze({
    header: { navigationActionRendered: false },
});
/**
 * @default-entity
 * @stable [09.01.2020]
 */
exports.DEFAULT_ROUTES_SETTINGS_ENTITY = Object.freeze({
    home: '/',
    logout: '/logout',
    oauthCallback: '/oauth2callback',
    oauthSignIn: '/oauth2sign_in',
    profile: '/profile',
});
/**
 * @default-entity
 * @stable [13.03.2020]
 */
exports.DEFAULT_OAUTH_SETTINGS_ENTITY = Object.freeze({
    clientId: 'spa',
    scope: 'internal-api',
});
/**
 * @default-entity
 * @stable [09.01.2020]
 */
exports.DEFAULT_ASYNC_LIBRARIES_SETTINGS_ENTITY = Object.freeze({
    googleMaps: 'https://maps.googleapis.com/maps/api/js',
});
/**
 * @default-entity
 * @stable [10.01.2020]
 */
exports.DEFAULT_GOOGLE_MAPS_SETTINGS_ENTITY = Object.freeze({
    componentRestrictions: { country: 'us' },
    lat: 34.0522,
    libraries: 'places,visualization',
    lng: -118.2436,
    prettyZoom: 17,
    zoom: 13,
});
/**
 * @stable [29.11.0219]
 */
exports.DEFAULT_PHONE_SETTINGS_ENTITY = Object.freeze({
    countryAbbr: 'US',
    uiMask: ['+', /\d/, '(', /\d/, /\d/, /\d/, ')', /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/],
});
/**
 * @default-entity
 * @stable [06.02.2020]
 */
exports.DEFAULT_URLS_SETTINGS_ENTITY = Object.freeze({
    emptyAvatar: 'media/no_avatar.jpg',
    pdfWorker: 'https://cdnjs.cloudflare.com/ajax/libs/pdf.js/2.0.489/pdf.worker.min.js',
});
/**
 * @stable [07.10.2019]
 */
exports.DEFAULT_MESSAGES_SETTINGS_ENTITY = Object.freeze({
    ADDRESS_SELECTION: 'Address selection',
    AN_ERROR_OCCURRED_DURING_LOADING_THE_FILE: 'An error occurred during loading the file',
    APPLICATION_IS_INITIALIZING: 'The app is initializing...',
    APPLY: 'Apply',
    BUILD: 'Build',
    CHANGES_YOU_MADE_WILL_NOT_BE_SAVED: 'Changes you made will not be saved',
    CLEAR_ALL: 'Clear all',
    CLOSE: 'Close',
    COMPARE_TO: 'Compare to',
    CREATE: 'Create',
    CUSTOM: 'Custom',
    DATA_HAS_BEEN_SUCCESSFULLY_SAVED: 'The data has been successfully saved',
    DATE: 'Date',
    DAY: 'Day',
    DETAILS_INFO: 'Details info',
    DIALOG_ACCEPT: 'Continue',
    DIALOG_CANCEL: 'Cancel',
    DIALOG_DISCARD: 'Discard',
    ENVIRONMENT: 'Environment',
    ERROR: 'Error',
    EXPORT: 'Export',
    FILTERS: 'Filters',
    FIRST: 'First',
    LAST: 'Last',
    LAST_MONTH: 'Last month',
    LAST_QUARTER: 'Last quarter',
    LAST_WEEK: 'Last week',
    LAST_YEAR: 'Last year',
    LOG_OUT: 'Log out',
    MAX_LENGTH_OF: '{length} of {maxLength}',
    NA: 'N/A',
    NEW_APP_VERSION_HAS_BEEN_DEPLOYED: 'The app has been updated! Let\'s go to the main page',
    NEXT: 'Next',
    NO_AVAILABLE_ITEMS_TO_SELECT: 'No available items to select',
    NO_DATA: 'No data',
    NOT_DATA_FOUND: 'No data found',
    OK: 'Ok',
    PAGES_INFO: '{from}-{to} of {count}',
    PATH: 'Path',
    PLEASE_WAIT: 'Please wait...',
    PLS_SEND_THIS_SCR_TO_SUPPORT_MANAGER: 'Please send this screenshot to your support manager',
    PREVIEW: 'Preview',
    PREVIOUS: 'Previous',
    PUT_MARKER_HERE: 'Put marker here',
    REFRESH: 'Refresh',
    RESET: 'Reset',
    RESTART_APP: 'Restart App',
    SAVE: 'Save',
    SEARCH: 'Search',
    SETTINGS: 'Settings',
    SHORT_PAGES_INFO: 'Page {page} of {count}',
    SOMETHING_WENT_WRONG: 'Something went wrong',
    THIS_MONTH: 'This month',
    THIS_QUARTER: 'This quarter',
    THIS_WEEK: 'This week',
    TODAY: 'Today',
    UNKNOWN_ERROR: 'Unknown error',
    UPLOAD_FILES_HERE: 'Upload a file(s) here',
    USER: 'User',
    WAITING: 'Waiting...',
    YEAR: 'Year',
    YESTERDAY: 'Yesterday',
});
/**
 * @default-entity
 * @stable [06.02.2020]
 */
exports.DEFAULT_NUMBER_CONVERTER_SETTINGS_ENTITY = Object.freeze({
    na: exports.DEFAULT_MESSAGES_SETTINGS_ENTITY.NA,
});
//# sourceMappingURL=settings-definition.interface.js.map