/// <reference types="react" />
import { IActionsWrapper, IActiveToolsWrapper, IDisabledWrapper, IFullWrapper, ILeftContentWrapper, IOnDownloadFileClickWrapper, IOnFilterClickWrapper, IOnRefreshClickWrapper, IRightContentWrapper, IToolbarToolsConfigurationWrapper } from '../definitions.interface';
import { IGenericContainerProps } from './generic-container-definition.interface';
import { IGenericComponentProps } from './generic-component-definition.interface';
import { IButtonProps } from './button-definition.interface';
import { IReduxListHolderEntity } from './list-definition.interface';
import { IReduxFormHolderEntity } from './form-definition.interface';
/**
 * @stable [22.04.2020]
 */
export declare enum ToolbarToolsEnum {
    CLEAR = 0,
    DOWNLOAD_FILE = 1,
    FILTER = 2,
    REFRESH = 3
}
/**
 * @classes
 * @stable [26.03.2020]
 */
export declare enum ToolbarToolsClassesEnum {
    FULL_TOOLBAR_TOOLS = "rac-full-toolbar-tools",
    TOOLBAR_TOOLS = "rac-toolbar-tools",
    TOOLBAR_TOOLS_ACTIVE_TOOL = "rac-toolbar-tools__active-tool"
}
/**
 * @presets-entity
 * @stable [10.05.2020]
 */
export interface IPresetsToolbarToolsEntity extends IActionsWrapper<Array<IButtonProps | ToolbarToolsEnum>>, IActiveToolsWrapper<ToolbarToolsEnum[]>, IDisabledWrapper, IFullWrapper, ILeftContentWrapper<JSX.Element>, IOnDownloadFileClickWrapper, IOnFilterClickWrapper, IOnRefreshClickWrapper, IRightContentWrapper<JSX.Element> {
}
/**
 * @generic-entity
 * @stable [22.04.2020]
 */
export interface IGenericToolbarToolsEntity extends IPresetsToolbarToolsEntity {
}
/**
 * @props
 * @stable [22.04.2020]
 */
export interface IToolbarToolsProps extends IGenericComponentProps, IGenericToolbarToolsEntity {
}
/**
 * @configuration-entity
 * @stable [15.06.2020]
 */
export interface IConfigurationToolbarToolsEntity<TProps = IToolbarToolsProps> extends IToolbarToolsConfigurationWrapper<TProps> {
}
/**
 * @generic-container-entity
 * @stable [15.06.2020]
 */
export interface IGenericToolbarToolsContainerEntity<TProps = IToolbarToolsProps> extends IConfigurationToolbarToolsEntity<TProps>, IReduxFormHolderEntity, IReduxListHolderEntity {
}
/**
 * @props
 * @stable [22.04.2020]
 */
export interface IToolbarToolsContainerProps<TProps = IToolbarToolsProps> extends IGenericContainerProps, IGenericToolbarToolsContainerEntity<TProps> {
}
/**
 * @stable [11.04.2020]
 */
export declare const TOOLBAR_TOOLS_DOWNLOAD_FILE_ACTION_TYPE = "toolbar.tools.download.file";
export declare const TOOLBAR_TOOLS_FILTER_ACTION_TYPE = "toolbar.tools.filter";
export declare const TOOLBAR_TOOLS_REFRESH_ACTION_TYPE = "toolbar.tools.refresh";
