"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventEmitter = void 0;
var eventEmitter = require("event-emitter");
var inversify_1 = require("inversify");
var EventEmitter = /** @class */ (function () {
    /**
     * @stable [17.01.2020]
     */
    function EventEmitter() {
        this.emitter = eventEmitter();
    }
    /**
     * @stable [17.01.2020]
     * @param {IEventEmitterSubscribeEntity} cfg
     * @returns {() => void}
     */
    EventEmitter.prototype.subscribe = function (cfg) {
        var _this = this;
        var autoUnsubscribing = cfg.autoUnsubscribing, callback = cfg.callback, _a = cfg.condition, condition = _a === void 0 ? function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return true;
        } : _a, eventName = cfg.eventName;
        var listener;
        var eventUnsubscriber = function () { return _this.emitter.off(eventName, listener); };
        listener = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (condition.apply(void 0, args)) {
                if (autoUnsubscribing) {
                    eventUnsubscriber();
                }
                callback();
            }
        };
        this.emitter.on(eventName, listener);
        return eventUnsubscriber;
    };
    /**
     * @stable [17.01.2020]
     * @param {string} event
     * @param {AnyT[]} args
     */
    EventEmitter.prototype.emit = function (event) {
        var _a;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        (_a = this.emitter).emit.apply(_a, __spreadArrays([event], args));
    };
    EventEmitter = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [])
    ], EventEmitter);
    return EventEmitter;
}());
exports.EventEmitter = EventEmitter;
//# sourceMappingURL=event-emitter.service.js.map