"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts_smart_logger_1 = require("ts-smart-logger");
var di_1 = require("../di");
var log_manager_service_1 = require("./log-manager.service");
var log_manager_event_payload_factory_service_1 = require("./log-manager-event-payload-factory.service");
var definition_1 = require("../definition");
ts_smart_logger_1.LoggerFactory.configure({
    debugLevelPath: '[^TransportFactory|^EffectsService|^RouterEffects|^connector.decorator]',
    warnLevelPath: '[^EffectsService]',
    logLevel: definition_1.DefaultEntities.ENVIRONMENT_ENTITY.prodMode ? ts_smart_logger_1.LoggerLevelEnum.ERROR_LEVEL : ts_smart_logger_1.LoggerLevelEnum.DEBUG_LEVEL,
});
di_1.bindInSingleton(di_1.DI_TYPES.LogManager, log_manager_service_1.LogManager);
di_1.bindInSingleton(di_1.DI_TYPES.LogManagerEventPayloadFactory, log_manager_event_payload_factory_service_1.LogManagerEventPayloadFactory);
//# sourceMappingURL=log.module.js.map