"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DEFAULT_APPLICATION_SETTINGS = void 0;
var util_1 = require("../util");
var definition_1 = require("../definition");
exports.DEFAULT_APPLICATION_SETTINGS = {
    signalRUrl: util_1.prepareUrl(definition_1.DefaultEntities.ENVIRONMENT_ENTITY.basePath + '/api/'),
    downloadUrl: util_1.prepareUrl(definition_1.DefaultEntities.ENVIRONMENT_ENTITY.basePath + '/api/download/?params='),
    emptyPictureUrl: 'media/no_avatar.jpg',
    companyName: 'Test company',
    transport: {
        method: 'post',
        withCredentials: true,
        blobDataContentType: 'application/octet-stream',
        formDataContentType: 'multipart/form-data',
        apiUrl: util_1.prepareUrl(definition_1.DefaultEntities.ENVIRONMENT_ENTITY.basePath + '/api/'),
        blobUrl: util_1.prepareUrl(definition_1.DefaultEntities.ENVIRONMENT_ENTITY.basePath + '/api/blobs/upload/'),
        uniqueParamName: '_dc',
    },
    messages: __assign(__assign({}, definition_1.DEFAULT_MESSAGES_SETTINGS_ENTITY), { acceptMessage: 'Accept', accessDeniedMessage: 'The access is restricted for you.', dataSaved: 'The data has been successfully saved.', emptyMessage: 'Start a search', errorMessage: 'Something went wrong. There was a problem loading your data', logoutNotificationMessage: 'You were logged out.', noItemsMessage: 'No items.', requestCancelErrorMessage: 'The request has been canceled by the user.', serviceTemporarilyUnavailableMessage: 'Service temporarily unavailable. Please try later.', sorryMessage: 'Sorry about that.', takeSnapshotMessage: 'Take a snapshot', waitingMessage: 'Waiting...', waitMessage: 'Please wait...' }),
    oauth: definition_1.DEFAULT_OAUTH_SETTINGS_ENTITY,
    routes: definition_1.DEFAULT_ROUTES_SETTINGS_ENTITY,
    asyncLibraries: definition_1.DEFAULT_ASYNC_LIBRARIES_SETTINGS_ENTITY,
    dateTime: __assign(__assign({}, definition_1.DEFAULT_DATE_TIME_SETTINGS_ENTITY), { dateFormat: 'YYYY-MM-DD', timeFormat: 'HH:mm:ss', uiMonthFormat: 'YYYY-MM', pstTimeFormat: 'hh:mm A', pstDateFormat: 'MMM DD', uiTimeMask: [/\d/, /\d/, ':', /\d/, /\d/, ':', /\d/, /\d/], uiShortTimeMask: [/\d/, /\d/, ':', /\d/, /\d/], uiTimePattern: '([0-1][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9])', uiShortTimePattern: '([0-1][0-9]|2[0-3]):([0-5][0-9])' }),
    bootstrap: {
        rootId: 'appId',
    },
    number: {
        uiPattern: definition_1.RegexpEnum.NUMBER,
    },
    components: definition_1.DefaultEntities.COMPONENTS_SETTINGS_ENTITY,
    currency: definition_1.DefaultEntities.CURRENCY_SETTINGS_ENTITY,
    elementsMarkers: definition_1.DEFAULT_ELEMENTS_MARKERS_SETTINGS_ENTITY,
    numberConverter: definition_1.DefaultEntities.NUMBER_CONVERTER_SETTINGS_ENTITY,
    phone: definition_1.DEFAULT_PHONE_SETTINGS_ENTITY,
    storage: definition_1.DEFAULT_STORAGE_SETTINGS_ENTITY,
    channel: {
        eventToListen: 'client-event-to-listen',
        eventToEmit: 'client-event-to-emit',
    },
    authorization: {
        isAuthorizationNeeded: true,
    },
    googleMaps: definition_1.DEFAULT_GOOGLE_MAPS_SETTINGS_ENTITY,
    urls: definition_1.DEFAULT_URLS_SETTINGS_ENTITY,
};
// TODO Remove duplication
Reflect.defineProperty(exports.DEFAULT_APPLICATION_SETTINGS.dateTime, 'currentDate', {
    get: function () { return new Date(); },
});
//# sourceMappingURL=settings.interface.js.map