import { IStorageSettingsEntity } from '../definition';
export declare class UniversalStorageEffects {
    private static readonly logger;
    private readonly logManager;
    private readonly settings;
    private readonly stateSerializer;
    private readonly storage;
    private readonly appStore;
    private isPreviousStatesAlreadyCleared;
    private syncStateWithStorageTask;
    private syncStateWithStorageTaskUnsubscriber;
    /**
     * @stable [17.11.2019]
     */
    constructor();
    /**
     * @stable [17.11.2019]
     * @returns {Promise<void>}
     */
    $onAppSyncState(): Promise<void>;
    /**
     * @stable [17.11.2019]
     */
    $onRegisterSyncStateTask(): void;
    /**
     * @stable [17.11.2019]
     */
    $onUnRegisterSyncStateTask(): void;
    /**
     * @stable [18.11.2019]
     * @param {boolean} silently
     */
    protected doUnRegisterSyncStateTask(silently?: boolean): void;
    /**
     * @stable [17.11.2019]
     * @returns {Promise<void>}
     */
    protected doSyncState(): Promise<void>;
    /**
     * @stable [17.11.2019]
     * @returns {Promise<void>}
     */
    protected syncState(): Promise<void>;
    /**
     * @stable [17.11.2019]
     * @returns {Promise<void>}
     */
    protected clearPreviousStates(): Promise<void>;
    /**
     * @stable [17.11.2019]
     * @returns {IStorageSettingsEntity}
     */
    protected get storageSettings(): IStorageSettingsEntity;
    /**
     * @stable [17.11.2019]
     * @returns {string}
     */
    protected get appStateKeyName(): string;
}
