"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeDestroyedContainerEffectsProxy = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var di_1 = require("../../di");
var definition_1 = require("../../definition");
var middleware_1 = require("../middleware");
var action_builder_1 = require("../../component/action.builder");
var action_1 = require("../../action");
/**
 * @stable [27.04.2020]
 * @param {IDestroyedContainerMiddlewareConfigEntity} cfg
 * @returns {string}
 */
var actionType = function (cfg) {
    switch (cfg.type) {
        case definition_1.DestroyedContainerTypesEnum.FILTER:
            return action_1.FilterActionBuilder.buildDestroyActionType(cfg.sectionName);
        case definition_1.DestroyedContainerTypesEnum.FORM:
            return action_1.FormActionBuilder.buildDestroyActionType(cfg.sectionName);
        case definition_1.DestroyedContainerTypesEnum.LIST:
            return action_builder_1.ListActionBuilder.buildDestroyActionType(cfg.sectionName);
        case definition_1.DestroyedContainerTypesEnum.TAB_PANEL:
            return action_1.TabPanelActionBuilder.buildDestroyActionType(cfg.sectionName);
    }
};
/**
 * @effects-proxy-factory
 * @stable [09.09.2020]
 *
 * @param config
 */
exports.makeDestroyedContainerEffectsProxy = function (config) {
    return function () {
        // Define the class only
        var Effects = /** @class */ (function () {
            function Effects() {
                this.$onDestroy = function () { return middleware_1.MiddlewareFactories.destroyedContainerMiddleware(config); };
            }
            Effects_1 = Effects;
            var Effects_1;
            __decorate([
                redux_effects_promise_1.EffectsService.effects(actionType(config)),
                __metadata("design:type", Object)
            ], Effects.prototype, "$onDestroy", void 0);
            Effects = Effects_1 = __decorate([
                di_1.provideInSingleton(Effects_1)
            ], Effects);
            return Effects;
        }());
    };
};
//# sourceMappingURL=destroyed-container-effects.proxy.js.map