"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilteredListMiddlewareFactories = void 0;
var action_1 = require("../../action");
var loaded_list_middleware_1 = require("./loaded-list.middleware");
var util_1 = require("../../util");
/**
 * @stable [09.09.2020]
 * @middleware
 *
 * @param cfg
 */
var makeFilteredListApplyMiddleware = function (cfg) {
    return [loaded_list_middleware_1.LoadedListMiddlewareFactories.loadedListMiddleware(cfg)];
};
/**
 * @stable [09.09.2020]
 * @middleware
 *
 * @param cfg
 */
var makeFilteredListDeactivateMiddleware = function (cfg) {
    return [
        action_1.FilterActionBuilder.buildDestroyAction(util_1.SectionUtils.asFormOrListSection(cfg)),
        loaded_list_middleware_1.LoadedListMiddlewareFactories.loadedListMiddleware(cfg)
    ];
};
/**
 * @stable [09.09.2020]
 */
var FilteredListMiddlewareFactories = /** @class */ (function () {
    function FilteredListMiddlewareFactories() {
    }
    FilteredListMiddlewareFactories.filteredListApplyMiddleware = makeFilteredListApplyMiddleware;
    FilteredListMiddlewareFactories.filteredListDeactivateMiddleware = makeFilteredListDeactivateMiddleware;
    return FilteredListMiddlewareFactories;
}());
exports.FilteredListMiddlewareFactories = FilteredListMiddlewareFactories;
//# sourceMappingURL=filtered-list.middleware.js.map