"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransportResponseFactory = void 0;
var inversify_1 = require("inversify");
var R = require("ramda");
var util_1 = require("../../../util");
var TransportResponseFactory = /** @class */ (function () {
    function TransportResponseFactory() {
    }
    /**
     * This is a default error response handler. The core uses Axios by default therefore here we gets a response from this one.
     *
     * @stable [01.02.2019]
     * @param {TransportResponseFactoryPayloadT} payloadEntity
     * @returns {ITransportResponseFactoryEntity}
     */
    TransportResponseFactory.prototype.makeErrorResponse = function (payloadEntity) {
        var response = payloadEntity.response;
        return __assign({ error: true, message: payloadEntity.message }, (response && {
            status: response.status,
            statusText: response.statusText,
        }));
    };
    /**
     * This is a default response handler. The core uses Axios by default therefore here we gets a response from this one.
     *
     * @stable [02.02.2019]
     * @param {ITransportRequestEntity} req
     * @param {IDataWrapper} payloadEntity
     * @returns {ITransportResponseFactoryEntity}
     */
    TransportResponseFactory.prototype.makeResponse = function (req, payloadEntity) {
        var data = payloadEntity.data;
        var errorData = this.readResponseErrorData(data);
        if (!R.isNil(errorData)) {
            return __assign(__assign({}, errorData), { error: true });
        }
        return {
            result: util_1.isFn(req.responseReader) ? req.responseReader(data) : this.readResponseData(data),
        };
    };
    /**
     * @stable [02.02.2019]
     * @param {AnyT} data
     * @returns {AnyT}
     */
    TransportResponseFactory.prototype.readResponseData = function (data) {
        return data;
    };
    /**
     * @stable [04.02.2019]
     * @param {AnyT} data
     * @returns {ITransportResponseFactoryEntity}
     */
    TransportResponseFactory.prototype.readResponseErrorData = function (data) {
        return null;
    };
    TransportResponseFactory = __decorate([
        inversify_1.injectable()
    ], TransportResponseFactory);
    return TransportResponseFactory;
}());
exports.TransportResponseFactory = TransportResponseFactory;
//# sourceMappingURL=transport-response-factory.service.js.map