import { IExtendedEntity, IExtendedFormEntity, IFieldProps, IFormProps, IGenericFieldEntity, IGenericFormEntity, IPresetsFieldEntity, IPresetsFormEntity, IPresetsTabEntity, IReduxFormHolderEntity } from '../definition';
import { AnyT, IEntity } from '../definitions.interface';
/**
 * @stable [06.05.2020]
 * @param {IExtendedFormEntity<TEntity>} wrapper
 * @param {IGenericFieldEntity} fieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldValue: <TEntity = IEntity>(wrapper: IExtendedFormEntity<TEntity>, fieldProps: IGenericFieldEntity) => AnyT;
/**
 * @stable [23.04.2020]
 * @param {IFormProps<TEntity>} entity
 * @returns {boolean}
 */
export declare const isFormDirty: <TEntity = IEntity>(entity: IFormProps<TEntity>) => boolean;
/**
 * @stable [23.03.2020]
 * @param {IFormProps} formProps
 * @param {IGenericFieldEntity} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldDisabled: (formProps: IFormProps, fieldProps: IGenericFieldEntity) => boolean;
/**
 * @stable [03.02.2020]
 * @param {IFormProps<TEntity extends IEntity>} formProps
 * @returns {boolean}
 */
export declare const isFormSubmittable: <TEntity extends IEntity = IEntity>(formProps: IFormProps<TEntity>) => boolean;
/**
 * @stable [23.03.2020]
 * @param {IFormProps<TEntity extends IEntity>} formProps
 * @returns {boolean}
 */
export declare const isFormResettable: <TEntity extends IEntity = IEntity>(formProps: IFormProps<TEntity>) => boolean;
/**
 * @stable [11.05.2020]
 */
export declare class FormUtils {
    static readonly fieldDisplayValue: <TEntity = IEntity>(formEntity: IExtendedFormEntity<TEntity>, fieldProps: IFieldProps, defaultFieldProps?: IFieldProps) => any;
    static readonly fieldOriginalValue: <TEntity = IEntity>(entity: IExtendedEntity<TEntity>, fieldProps: IFieldProps) => unknown;
    static readonly inProgress: <TEntity = IEntity>(entity: IReduxFormHolderEntity<TEntity>) => boolean;
    static readonly isChanged: <TEntity = IEntity>(entity: IReduxFormHolderEntity<TEntity>) => boolean;
    static readonly isDisabled: <TEntity = IEntity>(entity: IGenericFormEntity<TEntity>) => boolean;
    static readonly isFieldChangeable: (formEntity: IPresetsFormEntity<IEntity>, fieldEntity: IPresetsFieldEntity) => boolean;
    static readonly isFieldReadOnly: (formEntity: IPresetsFormEntity<IEntity>, fieldEntity: IPresetsFieldEntity) => boolean;
    static readonly isReady: <TEntity = IEntity>(formProps: IGenericFormEntity<TEntity>) => boolean;
    static readonly isTabActive: <TEntity = IEntity>(holderFormEntity: IReduxFormHolderEntity<TEntity>, tabEntity: IPresetsTabEntity) => boolean;
    static readonly isTouched: <TEntity = IEntity>(entity: IReduxFormHolderEntity<TEntity>) => boolean;
    static readonly isValid: <TEntity = IEntity>(entity: IGenericFormEntity<TEntity>) => boolean;
}
