"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MapAsWrapperUtils = void 0;
var filter_1 = require("./filter");
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param stack
 */
var mapStack = function (stack) {
    return filter_1.FilterUtils.defValuesFilter({ stack: stack });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param user
 */
var mapUser = function (user) {
    return filter_1.FilterUtils.defValuesFilter({ user: user });
};
/**
 * @map-as-wrapper
 *
 * @stable [10.08.2020]
 * @param progress
 */
var mapProgress = function (progress) {
    return filter_1.FilterUtils.defValuesFilter({ progress: progress });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param options
 */
var mapOptions = function (options) {
    return filter_1.FilterUtils.defValuesFilter({ options: options });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param layout
 */
var mapLayout = function (layout) {
    return filter_1.FilterUtils.defValuesFilter({ layout: layout });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param waitingForOptions
 */
var mapWaitingForOptions = function (waitingForOptions) {
    return filter_1.FilterUtils.defValuesFilter({ waitingForOptions: waitingForOptions });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param form
 */
var mapForm = function (form) {
    return filter_1.FilterUtils.defValuesFilter({ form: form });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param tabPanel
 */
var mapTabPanel = function (tabPanel) {
    return filter_1.FilterUtils.defValuesFilter({ tabPanel: tabPanel });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param disabled
 */
var mapDisabled = function (disabled) {
    return filter_1.FilterUtils.defValuesFilter({ disabled: disabled });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param sectionName
 */
var mapSectionName = function (sectionName) {
    return filter_1.FilterUtils.defValuesFilter({ sectionName: sectionName });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param notification
 */
var mapNotification = function (notification) {
    return filter_1.FilterUtils.defValuesFilter({ notification: notification });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param transport
 */
var mapTransport = function (transport) {
    return filter_1.FilterUtils.defValuesFilter({ transport: transport });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param channel
 */
var mapChannel = function (channel) {
    return filter_1.FilterUtils.defValuesFilter({ channel: channel });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param list
 */
var mapList = function (list) {
    return filter_1.FilterUtils.defValuesFilter({ list: list });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param queryFilter
 */
var mapQueryFilter = function (queryFilter) {
    return filter_1.FilterUtils.defValuesFilter({ queryFilter: queryFilter });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param primaryFilter
 */
var mapPrimaryFilter = function (primaryFilter) {
    return filter_1.FilterUtils.defValuesFilter({ primaryFilter: primaryFilter });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param secondaryFilter
 */
var mapSecondaryFilter = function (secondaryFilter) {
    return filter_1.FilterUtils.defValuesFilter({ secondaryFilter: secondaryFilter });
};
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param {string} query
 * @returns {IQueryWrapper}
 */
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param query
 */
var mapQuery = function (query) { return filter_1.FilterUtils.defValuesFilter({ query: query }); };
/**
 * @map-as-wrapper
 *
 * @stable [27.07.2020]
 * @param dictionaries
 */
var mapDictionaries = function (dictionaries) {
    return filter_1.FilterUtils.defValuesFilter({ dictionaries: dictionaries });
};
/**
 * @map-as-wrapper
 *
 * @stable [30.07.2020]
 * @param activeValue
 */
var mapActiveValue = function (activeValue) {
    return filter_1.FilterUtils.defValuesFilter({ activeValue: activeValue });
};
/**
 * @stable [27.07.2020]
 */
var MapAsWrapperUtils = /** @class */ (function () {
    function MapAsWrapperUtils() {
    }
    MapAsWrapperUtils.activeValue = mapActiveValue; /* stable [30.07.2020] */
    MapAsWrapperUtils.channel = mapChannel; /* stable [27.07.2020] */
    MapAsWrapperUtils.dictionaries = mapDictionaries; /* stable [27.07.2020] */
    MapAsWrapperUtils.disabled = mapDisabled; /* stable [07.05.2020] */
    MapAsWrapperUtils.form = mapForm; /* stable [08.05.2020] */
    MapAsWrapperUtils.layout = mapLayout; /* stable [27.07.2020] */
    MapAsWrapperUtils.list = mapList; /* stable [27.07.2020] */
    MapAsWrapperUtils.notification = mapNotification; /* stable [27.07.2020] */
    MapAsWrapperUtils.options = mapOptions; /* stable [19.05.2020] */
    MapAsWrapperUtils.primaryFilter = mapPrimaryFilter; /* stable [27.07.2020] */
    MapAsWrapperUtils.progress = mapProgress; /* stable [10.08.2020] */
    MapAsWrapperUtils.query = mapQuery; /* stable [08.05.2020] */
    MapAsWrapperUtils.queryFilter = mapQueryFilter; /* stable [08.05.2020] */
    MapAsWrapperUtils.secondaryFilter = mapSecondaryFilter; /* stable [27.07.2020] */
    MapAsWrapperUtils.sectionName = mapSectionName; /* stable [08.05.2020] */
    MapAsWrapperUtils.stack = mapStack; /* stable [27.07.2020] */
    MapAsWrapperUtils.tabPanel = mapTabPanel; /* stable [27.07.2020] */
    MapAsWrapperUtils.transport = mapTransport; /* stable [27.07.2020] */
    MapAsWrapperUtils.user = mapUser; /* stable [27.07.2020] */
    MapAsWrapperUtils.waitingForOptions = mapWaitingForOptions; /* stable [19.05.2020] */
    return MapAsWrapperUtils;
}());
exports.MapAsWrapperUtils = MapAsWrapperUtils;
//# sourceMappingURL=map-as-wrapper.js.map