/// <reference types="googlemaps" />
import { IPlaceEntity, PlaceEntityValueT } from '../definition';
/**
 * @stable [01.08.2018]
 * @param {google.maps.GeocoderAddressComponent} cmp
 * @param {(cmp: google.maps.GeocoderAddressComponent) => TType} extractor
 * @returns {TType}
 */
export declare const toPlaceDescription: <TType>(cmp: google.maps.GeocoderAddressComponent, extractor: (cmp: google.maps.GeocoderAddressComponent) => TType) => TType;
/**
 * @stable [04.08.2018]
 * @param {google.maps.GeocoderResult | google.maps.places.PlaceResult} place
 * @returns {IPlaceEntity}
 */
export declare const asPlaceEntity: (place: google.maps.GeocoderResult | google.maps.places.PlaceResult) => IPlaceEntity;
/**
 * @stable [17.05.2020]
 */
export declare class PlaceUtils {
    static formatPlaceEntity: (placeEntity: IPlaceEntity<string>) => string;
    static fromPlaceEntityToDisplayValue: (placeEntity: PlaceEntityValueT, placeEntityFormatter?: (placeEntity: IPlaceEntity<string>) => string) => string;
}
