"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RowUtils = void 0;
var R = require("ramda");
var entity_1 = require("./entity");
var number_1 = require("./number");
var type_1 = require("./type");
/**
 * @stable [17.08.2020]
 * @param row
 */
var isOddHighlighted = function (row) {
    return row.highlightOdd !== false && (type_1.TypeUtils.isNumber(row.index)
        ? number_1.NumberUtils.isOddNumber(row.index)
        : false);
};
/**
 * @stable [18.08.2020]
 * @param row
 */
var isHovered = function (row) {
    return row.hovered && !row.disabled;
};
/**
 * @stable [18.08.2020]
 * @param row
 */
var isSelectable = function (row) {
    return row.selectable
        && !row.disabled
        && type_1.TypeUtils.isFn(row.onClick)
        && !entity_1.EntityUtils.isPhantomEntity(row.entity);
};
/**
 * @stable [18.08.2020]
 * @param row
 */
var isIndexed = function (row) {
    return row.indexed && !R.isNil(row.entity);
};
/**
 * @stable [17.08.2020]
 */
var RowUtils = /** @class */ (function () {
    function RowUtils() {
    }
    RowUtils.isHovered = isHovered;
    RowUtils.isIndexed = isIndexed;
    RowUtils.isOddHighlighted = isOddHighlighted;
    RowUtils.isSelectable = isSelectable;
    return RowUtils;
}());
exports.RowUtils = RowUtils;
//# sourceMappingURL=row.js.map