import { Store } from 'redux';
import { IEnvironment, ILogManagerEventPayloadFactory, IUniversalStoreEntity } from '../definition';
import { IDateConverter } from '../converter';
import { AnyT } from '../definitions.interface';
export declare class LogManagerEventPayloadFactory implements ILogManagerEventPayloadFactory {
    private static readonly logger;
    protected readonly dc: IDateConverter;
    protected readonly environment: IEnvironment;
    protected readonly store: Store<IUniversalStoreEntity>;
    /**
     * @stable [17.10.2019]
     * @param {string} category
     * @param {string} eventAction
     * @param {AnyT} payload
     * @returns {string}
     */
    provideAction(category: string, eventAction: string, payload?: AnyT): string;
    /**
     * @stable [17.10.2019]
     * @param {string} category
     * @param {string} eventAction
     * @param {AnyT} payload
     * @returns {string}
     */
    provideCategory(category: string, eventAction: string, payload?: AnyT): string;
    /**
     * @stable [17.10.2019]
     * @param {string} category
     * @param {string} eventAction
     * @param {AnyT} payload
     * @returns {string}
     */
    provideLabel(category: string, eventAction: string, payload?: AnyT): string;
    /**
     * @stable [17.10.2019]
     * @param {AnyT} payload
     * @returns {string}
     */
    protected getEventLabel(payload: AnyT): string;
}
